﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Windows.Forms;
using Syncfusion.Windows.Forms.Grid;
using Syncfusion.GridHelperClasses;
using Syncfusion.Windows.Forms.Grid.Grouping;
using Syncfusion.Grouping;

namespace WindowsFormsApplication1
{
    public partial class Form1 : Form
    {
        public Form1()
        {
            InitializeComponent();
            this.gridGroupingControl1.DataSource = CreateTable();            
           // this.gridGroupingControl1.TableModel[5, 3].CellValue = Int32.MaxValue;
            this.gridGroupingControl1.TableModel[5, 3].CellType = GridCellTypeName.TextBox;
            this.gridGroupingControl1.TableModel[5, 3].Text = "123456789012";
            String s = (this.gridGroupingControl1.TableModel[5, 3].Text).ToString();
            int count = s.Length;
            String sd = this.gridGroupingControl1.TableModel[5, 3].Text;            
            int number2;
            bool result = Int32.TryParse(this.gridGroupingControl1.TableModel[5, 3].Text, out number2);
            if(result == false)
            {                 
                 for(int i = count-1 ;i > 9 ;i--)
                 {              
                    sd = sd.Remove(i);
                    this.gridGroupingControl1.TableModel[5, 3].Text = sd;
                }
                MessageBox.Show("Not enter more than Int32 Value"); 
            }
            this.gridGroupingControl1.TableDescriptor.Columns["I3"].Appearance.AnyRecordFieldCell.MaxLength = sd.Length;
            this.gridGroupingControl1.TableControlCurrentCellKeyPress += new GridTableControlKeyPressEventHandler(gridGroupingControl1_TableControlCurrentCellKeyPress);
        }

        void gridGroupingControl1_TableControlCurrentCellKeyPress(object sender, GridTableControlKeyPressEventArgs e)
        {
            GridCurrentCell cc = e.TableControl.CurrentCell;
            GridTableCellStyleInfo styleInfo = (GridTableCellStyleInfo)e.TableControl.GetTableViewStyleInfo(cc.RowIndex, cc.ColIndex);
            if (styleInfo.TableCellIdentity.DisplayElement.Kind == DisplayElementKind.Record
            && styleInfo.TableCellIdentity.Column.Name == "I3")
            {
                e.Inner.Handled = false;
                if (!char.IsNumber(e.Inner.KeyChar))
                {
                    MessageBox.Show("Enter only numeric value");
                    e.Inner.Handled = true;
                }                    
            }
        }
      
        int rowcount = 20;
        DataTable dt = new DataTable();
        private DataTable CreateTable()
        {
            dt.Columns.Add("I1");
            dt.Columns.Add("I2");
            dt.Columns.Add("I3");
            dt.Columns.Add("I4");
            dt.Columns.Add("I5");
            dt.Columns.Add("I6");
            dt.Columns.Add("I7");
            for (int i = 0; i < rowcount; i++)
            {
                DataRow dr = dt.NewRow();
                Random r = new Random();
                dr[0] = 10 + r.Next(20);
                dr[1] = 20 + r.Next(30);
                dr[2] = 30 + r.Next(40);
                dr[3] = 50 + r.Next(50);
                dr[4] = 40 + r.Next(30);
                dr[5] = 40 + r.Next(40);
                dr[6] = 60 + r.Next(60);
                dt.Rows.Add(dr);
            }
            return dt;
        }
    }
}
